<template>
  <div>
    <div class="page-title">
      <h3>{{ 'Categories' | localization }}</h3>
    </div>
    <section>

      <Loader v-if="loading" />

      <div v-else class="row">

        <Creation @created="createdCategory" />

        <Editing
            :key="categories.length + updatedCount"
            @updated="updatedCategory"
            :categories="categories"
            v-if="categories.length"
        />

        <p v-else class="center">
          {{ 'No categories yet' | localization }}
        </p>

      </div>
    </section>
  </div>
</template>

<script>

import Editing from "@/components/category/Editing";
import Creation from "@/components/category/Creation";
import {minValue, required} from "vuelidate/lib/validators";

export default {
  name: "Categories",
  components: {
    Creation, Editing
  },
  data: () => ({
    categories: [],
    loading: true,
    updatedCount: 0
  }),
  async mounted() {
    this.categories = await this.$store.dispatch('getCategories');
    this.loading = false;
  },
  methods: {
    createdCategory(category) {
      this.categories.push(category);
    },
    updatedCategory(category) {
      const index = this.categories.findIndex(c => c.id === category.id);
      this.categories[index] = category;
      this.updatedCount++;
    }
  }
}
</script>

<style scoped>

</style>